const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const api_tokens = sequelize.define(
    'api_tokens',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

token_hash: {
        type: DataTypes.TEXT,
      
      

      },

expires_at: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"revoked",


"expired"

        ],

      },

last_used_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  api_tokens.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.api_tokens.belongsTo(db.api_clients, {
      as: 'api_client',
      foreignKey: {
        name: 'api_clientId',
      },
      constraints: false,
    });

    db.api_tokens.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.api_tokens.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.api_tokens.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.api_tokens.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return api_tokens;
};


